(* fonction qui ajoute 32 en tete de liste s'il n'apparait pas deja,
sinon laisse la liste inchangee *)

exception Non;;

let ajoute l =
  let rec ajoute_aux = function
    | [] -> raise Non
    | x::xs -> if x=32 then x::xs else x::(ajoute_aux xs)
  in
  try
    ajoute_aux l
  with | Non -> 32::l
;;

let ajoute2 l =
  let rec ajoute_aux = function
    | [] -> raise Non
    | (x::xs) as toto -> if x=32 then toto else x::(ajoute_aux xs)
  in
  try
    ajoute_aux l
  with | Non -> 32::l
;;













let ajoute' l =
  let rec ajoute_aux = function
    | [] -> raise Non
    | x::xs -> if x=32 then l else ajoute_aux xs
  in
  try
    ajoute_aux l
  with | Non -> 32::l
;;



let l0 = [52;32;17;3];;

ajoute l0 == l0;;
ajoute' l0 == l0;;


let f = function | [] -> [] | x::xs -> x::xs;;
f l0 = l0;;
f l0 == l0;;
List.tl (f l0) == List.tl (f l0);;
