module type affichage = sig
  val aff_int : int -> unit
  val aff_str : string -> unit
  val fin_ligne : unit -> unit
end

module A : affichage =
  struct
    let aff_int n = print_string "<";print_int n;print_string ">"
    let aff_str s = print_string "** ";print_string s
    let fin_ligne () = print_string " **\n"
  end

(* dfinition d'un module paramtr *)
module Suit_fonction (M:affichage) =
  struct
    let suit f = fun k ->
      begin
	let r = f k in
	M.aff_str "la fonction est appellee avec ";
	M.aff_int k;
	M.fin_ligne ();
	M.aff_str " et renvoie ";
	M.aff_int r;
	M.fin_ligne ()
      end
  end

(* on applique le foncteur  un module *)
module S = Suit_fonction (A)
	
(* exemple d'utilisation *)
let f = fun x -> x*x;;

let f' = S.suit f;;

f' 3;;

