type tree = Leaf | Node of node
and node = { left : tree; valeur : int; right : tree }
;;

let rec search k t =
  match t with
  | Leaf -> false
  | Node { left = tl; valeur = k'; right = tr } ->
      if k=k' then true
      else (search k tl) || (search k tr)
;;

exception Found;;

let search_tree k t =
  let rec search_aux = function
    | Leaf -> false
    | Node { left = tl; valeur = k'; right = tr } ->
	if k=k' then raise Found else
	let _ = search_aux tl in search_aux tr
  in
  try
    search_aux t
  with | Found -> true



