type expr =
    Const of int
  | Add of expr*expr
  | Sub of expr*expr
  | Mul of expr*expr
  | Div of expr*expr

let rec affiche_expr e =
  let aff_aux s a b = 
      begin
	print_string s;
	affiche_expr a;
	print_string ", ";
	affiche_expr b;
	print_string ")"
      end
  in
  match e with
  | Const k -> print_int k
  | Add(e1,e2) -> aff_aux "Add(" e1 e2
  | Sub(e1,e2) -> aff_aux "Sub(" e1 e2
  | Mul(e1,e2) -> aff_aux "Mul(" e1 e2
  | Div(e1,e2) -> aff_aux "Div(" e1 e2
