(* stdin dsigne l'entre standard (le clavier) *)
(* lexbuf est un canal ouvert sur stdin *)

let lexbuf = Lexing.from_channel stdin



(* on enchane les tuyaux: lexbuf est pass  Lexer.token,
   et le rsultat est donn  Parser.main *)

let parse () = Parser.main Lexer.token lexbuf

(* la boucle interactive *)
let calc () =
  try
    while true do
      let result = parse () in
      Expr.affiche_expr result; print_newline (); flush stdout
    done
  with _ -> (print_string "erreur de saisie\n")
;;

calc()
