%{
(* ici du code Caml *)
open Expr

%}
/* description des lexmes */

%token <int> INT       /* le lexme INT a un attribut entier */
%token PLUS MINUS TIMES DIV
%token LPAREN RPAREN
%token EOL             /* retour  la ligne */

%left PLUS MINUS        /* associativit + prcdence minimale */
%left TIMES DIV         /* prcdence maximale */

%start main             /* "start" signale le point d'entre */
%type <Expr.expr> main     /* on _doit_ donner le type du point d'entre */

%%

main:                       /*  droite, les valeurs associes */
    expr EOL                { $1 }
;
expr:			    
  | INT                     { Const $1 }
  | LPAREN expr RPAREN      { $2 }
  | expr PLUS expr          { Add($1,$3) }
  | expr MINUS expr         { Sub($1,$3) }
  | expr TIMES expr         { Mul($1,$3) }
  | expr DIV expr           { Div($1,$3) }
;
