(* ocaml -I +threads unix.cma threads.cma *)

let c : int Event.channel = Event.new_channel ();;

let envoi () = 
  let _ = Event.sync (Event.send c 32) in
  print_string "entier envoye!\n"
;;

(* Thread.create : ('a -> 'b) -> 'a -> t

`Thread.create funct arg' creates a new thread of control, in which
the function application funct arg is executed concurrently with the
other threads of the program. The application of Thread.create returns
the handle of the newly created thread.

*)

Thread.create envoi ();;

let hop () =
  let k1 = Event.sync (Event.receive c) in
  print_string "recu l'entier ";
  print_int k1;
  print_newline()
;;

Thread.create hop ();;

let e1 = Event.receive c;;

let e1' = Event.wrap e1 (fun x -> (Format.printf "hop la! %d\n%!" x));;

Thread.create envoi ();;

Thread.create (fun () -> Event.sync e1') ();;

